--
--	Ancillary
--

local ancillary      	= CreateFrame("Frame","AnciFrame",UIParent)
local ancillary_options	= CreateFrame("Frame","AnciOptions")

-- accounting variables

local ver="4.00"

-- Show/Hide Status of the buttons

local toggle=false
local landmount_sh=false
local flymount_sh=false

-- 

local fly
local land

-- button object variables/say Iu 

local arch_b
local surv_b
local reload_b
local hearth_b
local total_b=0
local on_off_b
local fly_b
local land_b
local trades_b={}
local trades_bid={}
local tpaths={}
local tfuncs={}

-- saved variables

Ancillary_vars =	{ scale,shutup,autoduel }

local Ancillary_opts =	{ scale,shutup,autoduel }

-- static popup dialog for ReloadUI confirmation
StaticPopupDialogs["ANC_RELOADUI"] = {
	text = "Reload User Interface?",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	OnAccept = function()
		ReloadUI();
	end,
	timeout = 0,
	hideOnEscape = 1
};

--
-- ancillary options functions
--

function ancillary_init_options()
	ancillary_options.name="Ancillary"
	ancillary_options.okay=ancillary_options_ok
	ancillary_options.cancel=ancillary_options_cancel
	ancillary_options:SetScript("OnShow",ancillary_options_show)
	
	ancillary_options.scaleslide=CreateFrame("Slider","ancioptionsscale",ancillary_options,"OptionsSliderTemplate")
	
	local scaleslide=ancillary_options.scaleslide
	
	scaleslide:SetWidth(100)
	scaleslide:SetHeight(16)
	scaleslide:SetPoint("TOPLEFT",ancillary_options,20,-50)
	_G[scaleslide:GetName().."Text"]:SetText("Ancillary Button Scale")
	_G[scaleslide:GetName().."High"]:SetText("1.0")
	_G[scaleslide:GetName().."Low"]:SetText("0.4")
	scaleslide:SetScript("OnValueChanged",ancillary_scale)
	
-- this is in deference to the guild leader of Silver Daggers on Silver Hand
-- his mod was shutthehellup
-- this does the same thing and so I named the option shutup

	ancillary_options.shutup=CreateFrame("checkbutton","ancillary_shutup",ancillary_options,"OptionsCheckButtonTemplate")
	
	local shutup=ancillary_options.shutup
	shutup:SetPoint("TOPLEFT",ancillary_options,20,-70)
	shutup:SetWidth(30)
	shutup:SetHeight(30)
	shutup:SetScript("OnClick",ancillary_shutupclick)

-- turn on and off the auto dismiss duels function

	ancillary_options.autoduel=CreateFrame("checkbutton","ancillary_autoduel",ancillary_options,"OptionsCheckButtonTemplate")
	
	local autoduel=ancillary_options.autoduel
	autoduel:SetPoint("TOPLEFT",ancillary_options,20,-90)
	autoduel:SetWidth(30)
	autoduel:SetHeight(30)
	autoduel:SetScript("OnClick",ancillary_autoduelclick)

-- make a copy of the settings so we can be properly handled in the options frame
	Ancillary_opts.scale=Ancillary_vars.scale
	Ancillary_opts.shutup=Ancillary_vars.shutup
	Ancillary_opts.autoduel=Ancillary_vars.autoduel
	
	ancillary_options:SetScript("OnEvent",ancillary_options_processevent)
	InterfaceOptions_AddCategory(ancillary_options)
end

--
-- adjust the options buttons accordingly if we enter/leave combat while its open
--

function ancillary_options_processevent(self,event,...)
	if event=="PLAYER_REGEN_DISABLED" then
		ancillary_options:UnregisterEvent("PLAYER_REGEN_DISABLED")
		ancillary_options:RegisterEvent("PLAYER_REGEN_ENABLED")
		ancillary_options_disableall()
	end

	if event=="PLAYER_REGEN_ENABLED" then
		ancillary_options:UnregisterEvent("PLAYER_REGEN_ENABLED")
		ancillary_options:RegisterEvent("PLAYER_REGEN_DISABLED")
		ancillary_options_enableall()
	end
end

function ancillary_scale()
	local s=ancillary_options.scaleslide:GetValue()
	
	Ancillary_vars.scale=s
	ancillary:SetScale(s)
end

function ancillary_autoduelclick()
	local yn=ancillary_options.autoduel:GetChecked()
	
	Ancillary_vars.autoduel=yn
	
	if yn then
		ancillary:RegisterEvent("DUEL_REQUESTED")
	else
		ancillary:UnregisterEvent("DUEL_REQUESTED")
	end
end

function ancillary_shutupclick()
	local yn=ancillary_options.shutup:GetChecked()
	
	Ancillary_vars.shutup=yn
	if yn then
		ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
	else
		ChatFrame_RemoveMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
	end
end

--
-- called if we cancel the changes in the options interface
--

function ancillary_options_cancel()
	local s=Ancillary_opts.scale
	local syn=Ancillary_opts.shutup
	local ayn=Ancillary_opts.autoduel

	Ancillary_vars.scale=s
	Ancillary_vars.shutup=syn
	Ancillary_vars.autoduel=ayn
	
	ancillary:SetScale(s)

	if ayn then
		ancillary:RegisterEvent("DUEL_REQUESTED")
	else
		ancillary:UnregisterEvent("DUEL_REQUESTED")
	end

	if syn then
		ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
	else
		ChatFrame_RemoveMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
	end
	
	ancillary_options:UnregisterAllEvents()
end

--
-- called if we press OK in the options interface
--

function ancillary_options_ok()
	-- make it so #1
	Ancillary_opts.scale=ancillary_options.scaleslide:GetValue()
	
	Ancillary_opts.shutup=ancillary_options.shutup:GetChecked()
	Ancillary_opts.autoduel=ancillary_options.autoduel:GetChecked()
	ancillary_options:UnregisterAllEvents()
end

--
-- this is called whenever the options window appears
-- we want the controls to reflect current settings
--

function ancillary_options_show()
	-- set the values of the options buttons/sliders
	if UnitAffectingCombat("player") then
		ancillary_options_disableall()
		ancillary_options:RegisterEvent("PLAYER_REGEN_ENABLED")
	else
		ancillary_options_enableall()
		ancillary_options:RegisterEvent("PLAYER_REGEN_DISABLED")
	end

	ancillary_options.scaleslide:SetValue(Ancillary_vars.scale)

	ancillary_options.shutup:SetChecked(Ancillary_vars.shutup)
	_G[ancillary_options.shutup:GetName().."Text"]:SetText("ShutUp Module Status")

	ancillary_options.autoduel:SetChecked(Ancillary_vars.autoduel)
	_G[ancillary_options.autoduel:GetName().."Text"]:SetText("Auto-Decline Duel Requests")
	
end

--
-- call this to disable the options settings
-- used when we are in combat and the options window is open
--

function ancillary_options_disableall()
-- effectively disable the slider
	local scaleslide=ancillary_options.scaleslide
	local s=scaleslide:GetValue()
	
	scaleslide:SetMinMaxValues(s,s)
	scaleslide:SetValueStep(0)
end

--
-- call this to restore the functions of the options window
--

function ancillary_options_enableall()
	local scaleslide=ancillary_options.scaleslide

	scaleslide:SetMinMaxValues(0.4,1.0)
	scaleslide:SetValueStep(0.05)
end

--
-------------------------
-- end options stuff
-------------------------
--

function ancillary:new()

	self:SetToplevel(true)
	self:EnableMouse(true)
	self:SetMovable(true)
	self:SetWidth(32)
	self:SetHeight(32)

	self:SetBackdrop({
				bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
				edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
				tile=1, tileSize=10, edgeSize=10,
				insets={left=3, right=3, top=3, bottom=3}
				})
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("VARIABLES_LOADED")
	self:SetScript("OnEvent",self.processevent)
	self:SetPoint("CENTER",UIParent)
	self:Show()
end

function ancillary_startdrag(self,button)
	ancillary:StartMoving()
end

function ancillary_stopdrag(self,button)
	ancillary:StopMovingOrSizing()
end

function ancillary:mouseup(button)
	if button=="LeftButton" then
		ancillary:togglebutts()
	end
end

function ancillary:processevent(event)
	if event=="PLAYER_LOGIN" then
		self:buildbuttons()
		-- intiate the options panel
		ancillary_init_options()
	end

	if event=="BAG_UPDATE" then
		self:invchanged()
	end
	
	if (event=="DUEL_REQUESTED" and Ancillary_vars.autoduel) then
		CancelDuel()
	end

	if event=="VARIABLES_LOADED" then
		if Ancillary_vars.scale==nil or Ancillary_vars.scale==0 then Ancillary_vars.scale=1.0 end
		if Ancillary_vars.shutup==nil then Ancillary_vars.shutup=false end
		if Ancillary_vars.autoduel==nil then Ancillary_vars.autoduel=false end

		ancillary:SetScale(Ancillary_vars.scale)
		
		if Ancillary_vars.shutup then
		end
		
		if Ancillary_vars.autoduel then
			ancillary:RegisterEvent("DUEL_REQUESTED")
		end

		if Ancillary_vars.shutup then
			ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
		else
			ChatFrame_RemoveMessageEventFilter("CHAT_MSG_YELL", ancillary_yellfilter)
		end
	end
end

function ancillary_yellfilter(msg)
	if ancillary_InACity() then
		return true
	end
	return false
end

function ancillary_InACity()
	local z=GetRealZoneText()
	local city	=	{	"Darnassus",
						"Moonglade",
						"Orgrimmar",
						"The Exodar",
						"Thunder Bluff",
						"Mulgore",
						"Ironforge",
						"Silvermoon City",
						"Stormwind City",
						"Undercity",
						"Dalaran",
						"Shattrath City"
					}
	local i
	
	for i=1,12 do
		if z==city[i] then
			return true
		end
	end
end

function ancillary:buildbuttons()

	local hearth=false
	local W
	local H
	local x
	local y
	local dist
	local minx
	local maxy

-- Create the main button
	if on_off_b==nil then
		on_off_b = CreateFrame("Button","anc_main",ancillary,"SecureActionButtonTemplate")
	end

-- Set the image for the button
	on_off_b:SetNormalTexture("Interface\\Addons\\Ancillary\\Icons\\anci_icon.tga")
	on_off_b:SetPushedTexture("Interface\\Addons\\Ancillary\\Icons\\anci_icon.tga")

-- Gather its width and height because the textures are larger than the button as given
-- this way we can set those sizes right and make all the other buttons match the size	
	W = 32*Ancillary_vars.scale
	H = 32*Ancillary_vars.scale
	on_off_b:SetSize(32,32)
	
-- also do a calculation we will use several times later based on W and H
-- this happens to be the distance from the center of the square button to one of its corners
-- times 2 (thus using the entire Width and Height and not just half)
	dist = sqrt(W^2+H^2)+8

--	on_off_b:GetNormalTexture():SetWidth(W)
--	on_off_b:GetNormalTexture():SetHeight(H)

--	on_off_b:GetPushedTexture():SetWidth(W)
--	on_off_b:GetPushedTexture():SetHeight(H)
	
	on_off_b:SetPoint("CENTER",ancillary)
	on_off_b:SetScript("OnMouseDown",self.mousedown)
	on_off_b:SetScript("OnMouseUp",self.mouseup)
	on_off_b:RegisterForDrag("RightButton")
	on_off_b:SetScript("OnDragStart",ancillary_startdrag)
	on_off_b:SetScript("OnDragStop",ancillary_stopdrag)
	on_off_b:Show()

-- check for a hearthstone

  if hearth_b==nil then
    hearth_b = CreateFrame("Button","ancihearth",ancillary,"SecureActionButtonTemplate")
    hearth_b.cooldown=CreateFrame("Cooldown","ancihearthCooldown",hearth_b,"CooldownFrameTemplate")
	end
	
	hearth_b:SetNormalTexture("Interface\\Icons\\INV_Misc_Rune_01")
	hearth_b:SetPushedTexture("Interface\\Icons\\INV_Misc_Rune_01")
	hearth_b:SetSize(W,H)

  x = -(dist * cos(0))
	y = dist * sin(0)

	minx = x
	
	hearth_b:SetPoint("CENTER",ancillary,x,y)
	hearth_b:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	hearth_b:SetScript("OnEvent",ancillary_buttonevent)
	hearth_b:SetScript("OnEnter",ancillary_tooltipon)
	hearth_b:SetScript("OnLeave",ancillary_tooltipoff)
	hearth_b:Hide()

-- check for a hearthstone
-- itemID for hearthstone is 6948
	hearth = ancillary:hashearthstone()
	
	if hearth then
		hearth_b:Enable()
	else
		hearth_b:Disable()
	end
	
-- enumerate the inventory/skills for the rest of the buttons
	local trades=self.enumeratetrades()
	
	total_b=trades

-- Create the surrounding buttons (originally in hidden state)
	if trades then
		-- do some calculations to get theta and range
--		local theta = 360/(trades+1)
		local theta = 360/8
		
		for i = 1, trades do
			if trades_b[i]==nil then
				trades_b[i]=CreateFrame("Button","anc"..i.."button",ancillary,"SecureActionButtonTemplate")
				trades_b[i].cooldown=CreateFrame("Cooldown","anc"..i.."buttonCooldown",trades_b[i],"CooldownFrameTemplate")
			end
			
			trades_b[i]:SetNormalTexture(tpaths[i])
			trades_b[i]:SetPushedTexture(tpaths[i])
      trades_b[i]:SetSize(W,H)
		
			-- flip the coordinates so that the first button is actually
			-- in the negative direction along the X axis and the buttons appear clockwise around the
			-- center
			
			-- this is a classic polar to cartesian conversion
			
			x = -(dist * cos(theta*i))
			y = dist * sin(theta*i)
			
			trades_b[i]:SetPoint("CENTER",on_off_b,x,y)
			trades_b[i]:SetAttribute("type1","spell")
			trades_b[i]:SetAttribute("spell",trades_bid[i])
			trades_b[i]:SetScript("OnEnter",ancillary_tooltipon)
			trades_b[i]:SetScript("OnLeave",ancillary_tooltipoff)
			trades_b[i].tipID=trades_bid[i]
			trades_b[i]:Hide()
			
			i=i+1
		end
	end
	
-- Create the two archaeology buttons if the user has archaeology
	
	local archaelogy={78670,88961,89718,89719,89720,89721,89722};

	local spellName,spellIcon,ID=ancillary:SpellIsInBookFromList(archaelogy)
	
	if spellName then
		-- set archaelogy buttons on
		if arch_b==nil then
			arch_b=CreateFrame("Button","ancarchaeologybutton",ancillary,"SecureActionButtonTemplate")
		end
			
		arch_b:SetNormalTexture(spellIcon)
		arch_b:SetPushedTexture(spellIcon)
		arch_b:SetSize(W,H)
			
		arch_b:SetPoint("CENTER",on_off_b,30,-90)
		arch_b:SetAttribute("type1","spell")
		arch_b:SetAttribute("spell",spellName)
		arch_b:SetScript("OnEnter",ancillary_tooltipon)
		arch_b:SetScript("OnLeave",ancillary_tooltipoff)
		arch_b.tipID=ID
		arch_b:Hide()
	end
		
	local survey={80451}
		
	spellName,spellIcon,ID=ancillary:SpellIsInBookFromList(survey) -- spell ID for survey
	if spellName then
		DEFAULT_CHAT_FRAME:AddMessage(spellName)
		if surv_b==nil then
			surv_b=CreateFrame("Button","ancsurveybutton",ancillary,"SecureActionButtonTemplate")
		end

		surv_b:SetNormalTexture(spellIcon)
		surv_b:SetPushedTexture(spellIcon)
		surv_b:SetSize(W,H)

		surv_b:SetPoint("CENTER",on_off_b,60,-90)
		surv_b:SetAttribute("type1","spell")
		surv_b:SetAttribute("spell",spellName)
		surv_b:SetScript("OnEnter",ancillary_tooltipon)
		surv_b:SetScript("OnLeave",ancillary_tooltipoff)
		surv_b.tipID=ID
		surv_b:Hide()
	end
	
-- Create the UI Reset button
	maxy = -(H*2+8)

	if reload_b==nil then
		reload_b=CreateFrame("Button","anc_reload_button",ancillary,"UIPanelButtonTemplate")
	end
	
	reload_b:SetText("Reload UI")
	reload_b:SetWidth(reload_b:GetTextWidth()+12)
	reload_b:SetHeight(reload_b:GetTextHeight()+8)
	reload_b:SetPoint("CENTER",on_off_b,minx,maxy)
	reload_b:SetScript("OnMouseUp",ancillary.reloadui)
	reload_b:Hide()

	DEFAULT_CHAT_FRAME:AddMessage("Ancillary "..ver.." initialized.")
	DEFAULT_CHAT_FRAME:AddMessage(trades.." tradeskill buttons enumerated.")
	if hearth then
		DEFAULT_CHAT_FRAME:AddMessage("Hearthstone detected.")
	end
end

function ancillary_buttonevent(thisone,event,arg1,arg2,...)
	local t
	local start,dur,enable
	local name
	local cooldown

	if event=="SPELL_UPDATE_COOLDOWN" then
		cooldown=_G[thisone:GetName().."Cooldown"]
		if thisone==hearth_b then
			start,dur,enable=GetItemCooldown(6948)
		else
		t=thisone:GetAttribute("spell")
		DEFAULT_CHAT_FRAME:AddMessage(t)
			start,dur,enable=GetSpellCooldown(thisone:GetAttribute("spell"))
		end
		
		CooldownFrame_SetTimer(cooldown,start,dur,enable)
	end
end

function ancillary_tooltipon(self)
-- there is only one tooltip and its name is GameTooltip
  GameTooltip:SetOwner(self,"ANCHOR_BOTTOMLEFT")
  
	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	if self==hearth_b then
		local bag=self:GetAttribute("bag1")
		local slot=self:GetAttribute("slot")
		
		GameTooltip:SetBagItem(bag, slot)
	else
		GameTooltip:SetSpellByID(self.tipID,BOOKTYPE_SPELL)
	end
	GameTooltip:Show()
end

function ancillary_tooltipoff(self)
	GameTooltip:Hide()
end

function ancillary:IsSpellKnown(id)
	local s = FindSpellBookSlotBySpellID(id)
	if s and s<=MAX_SPELLS then
		local type,i = GetSpellBookItemInfo(s,BOOKTYPE_SPELL)
		return i==id and type ~='FUTURESPELL'
	end
end

function ancillary:SpellIsInBookFromList(testlist)
	local i=1
	local n=table.getn(testlist)
	
	for i=1,n do
		if ancillary:IsSpellKnown(testlist[i]) then
			local name,_,icon =GetSpellInfo(testlist[i])
			return name,icon,testlist[i]
		end
	end
	return nil
end

function ancillary:enumeratetrades()
	-- Decide what buttons will be needed

	-- iterate through all the spells to turn on what tradeskills this player has
	local t=1
	local skills={	["alchemy"]		={80731,51304,28596,11611,3464,3101,2259},
				["cooking"]		={88053,51296,33359,18260,3413,3102,2250},
				["first aid"]		={74559,45542,27028,10846,7924,3274,3273},
				["fishing"]		={88868,51294,33095,18248,7732,7731,7620},
				["enchanting"]		={74258,51313,28029,13920,7413,7412,7411},
				["disenchant"]		={13262},
				["smelting"]		={2656},
				["engineering"]		={82774,51306,30350,12656,4038,4037,4036},
				["jewelcrafting"]	={73318,51311,28897,28895,28894,25230,25229},
				["blacksmithing"]	={76666,51300,29844,9785,3538,3100,2018},
				["leatherworking"]	={81199,51302,32549,10662,3811,3104,2108},
				["tailoring"]		={75156,51309,26790,12180,3910,3909,3908},
				["inscription"]		={86008,45363,45361,45360,45359,45358,45357},
				["prospecting"]		={31252},
				["milling"]		={51005},
				["runeforging"]		={53428},
			}

	local spellName,spellIcon,ID
	local skillname,idlist
	for skillname,idlist in pairs(skills) do
		spellName,spellIcon,ID=ancillary:SpellIsInBookFromList(idlist)
		if spellName then
			tpaths[t]=spellIcon
			trades_bid[t]=ID
			t=t+1
		end
	end
	return t - 1
end

function ancillary:togglebutts()
-- if we are in combat, we can't hide/show buttons so don't toggle

	if UnitAffectingCombat("player") then
		return
	end

-- otherwise act normally

	local i
	
	toggle = not toggle
	
	if toggle then
		for i = 1, total_b do
			trades_b[i]:Show()
		end
		hearth_b:Show()
		reload_b:Show()
		if arch_b then
			arch_b:Show()
		end
	else
		for i = 1, total_b do
			trades_b[i]:Hide()
		end
		hearth_b:Hide()
		reload_b:Hide()
		if arch_b then
			arch_b:Hide()
		end
	end
end

--function ancillary:enumeratemounts()
	-- this is only for v3+
	
--	local i
	
--	for i = 1, GetNumCompanions("MOUNT") do
--	end
--end
	
function ancillary:invchanged()
-- this happens in case we buy/delete a mount or
-- get/delete a hearthstone
	local h
	
	h=ancillary:hashearthstone()
	if h then
		hearth_b:Enable()
	else
		hearth_b:Disable()
	end
end

function ancillary:hashearthstone()
	local b,s=self:scanbagsforitem(6948)

	hearth_b:SetAttribute("type1","item")
	hearth_b:SetAttribute("bag1",b)
	hearth_b:SetAttribute("slot",s)
	return(b and s)
end
	
function ancillary:scanbagsforitem(itemid)
--
-- return the bag# and bagslot# if itemid is found in the player inventory
--
	local b
	local s
	local n
	local bag=nil
	local slot=nil
	
	for b = 0, 4 do
		n = GetContainerNumSlots(b)
		if n then
			for s = 1, n do
				local istr
				local id
				local lk
				lk = GetContainerItemLink(b,s)		--[ get an item link
				if not (lk == nil) then
					_,_,istr = strsplit("|",lk)	--[ extract the item string from the link
					_, id = strsplit(":", istr)	--[ extract the itemID from the string

					if tonumber(id) == itemid then
						bag=b
						slot=s
						break
					end
				end
				s=s+1
			end
		end
		b=b+1
	end
	return bag,slot
end

function ancillary:reloadui()
	StaticPopup_Show("ANC_RELOADUI")
end

ancillary:new()

-- table data of all mounts
-- flyer = {}
-- ground = {}
